#include "AST.h"
#include "lgMacro.h"


const string ExprNode::emitPrefixOp( CodeContext &context, const char op[] )
{
    const string operand = child(0)->emitExpression( context );
    return string( op ) + '(' + operand + ')';
}


const string ExprNode::emitPostfixOp( CodeContext &context, const char op[] )
{
    const string operand = child(0)->emitExpression( context );
    return '(' + operand + ')' + op;
}


const string UnaryPlusNode::emitExpression2( CodeContext &context )
{
    return emitPrefixOp( context, "+" );
}


const string UnaryMinusNode::emitExpression2( CodeContext &context )
{
    return emitPrefixOp( context, "-" );
}


const string ComplementNode::emitExpression2( CodeContext &context )
{
    return emitPrefixOp( context, "~" );
}


const string NotNode::emitExpression2( CodeContext &context )
{
    return emitPrefixOp( context, "!" );
}
