// $Id: code.h 1.2.5.26 Mon, 14 Jun 1999 00:57:31 -0700 liblit $
#ifndef _INCLUDE_TITANIUM_CODE_H_
#define _INCLUDE_TITANIUM_CODE_H_

#define __SINST__
#include <string>

class Decl;
class FieldDecl;
class MethodDecl;
class TreeNode;


enum AssignKind { assignNormal, assignLocal, assignGlobal };

extern string cFieldName(Decl *);
extern string cMethodTypeString(const MethodDecl &);

extern bool codeGen_libs;
extern bool codeGen_main;
extern string codeGen_outdir;

extern bool compilerLocComments;
#define compilerLoc()							\
  (compilerLocComments ?						\
       string("/*") + __FILE__ + ':' + int2str(__LINE__) + "*/" :	\
       string(""))

// located in aux-code.cc
extern const string locComment(TreeNode *t);

// located in code-titan.cc
extern char *int2str(int);
extern char *long2hexstr(long val);

// defines to help to set points
#define SET_POINT_INDEX_START(sep, arity) \
	"cl_ti_domains_tiPoint" sep (arity) sep "_mt_setThis_jint_jint("
#define SET_POINT_INDEX_END(sep, index, value) \
	(index) sep ',' sep value sep ')'

#define NEW_POINT_1I_START(sep, arity) \
	"cl_ti_domains_tiPoint" sep (arity) sep "_mt_all_jint("
#define NEW_POINT_1I_END() \
	')'

// defines to help create domains

#define NEW_RECTDOMAIN_3PT_MAX_START(sep, arity) \
	"cl_ti_domains_tiRectDomain" sep (arity) sep "_mt_createWithMaxPoint" sep "_cl_ti_domains_tiPoint" sep (arity) sep "_cl_ti_domains_tiPoint" sep (arity) sep "_cl_ti_domains_tiPoint" sep (arity) sep '('
#define NEW_RECTDOMAIN_3PT_MAX_END() \
	')'

#define NEW_RECTDOMAIN_3PT_UPB_START(sep, arity) \
	"cl_ti_domains_tiRectDomain" sep (arity) sep "_mt_createWithUpbPoint" sep "_cl_ti_domains_tiPoint" sep (arity) sep "_cl_ti_domains_tiPoint" sep (arity) sep "_cl_ti_domains_tiPoint" sep (arity) sep '('
#define NEW_RECTDOMAIN_3PT_UPB_END() \
	')'

#define NEW_RECTDOMAIN_DOMAIN_START(sep, arity) \
	"cl_ti_domains_tiRectDomain" sep (arity) sep "_mt_tiRectDomain" sep (arity) sep "_GP_cl_ti_domains_tiDomain" sep (arity) sep '('
#define NEW_RECTDOMAIN_DOMAIN_END() \
	')'

#endif
