#include "AST.h"
#include "enact-context.h"


bool TreeNode::localEnactBits( const LocalEnactContext &context,
			       Modifiers &modifiers ) const
{
  const LocalSolution &solution = context.solution;
  const LocalSolution::const_iterator find = solution.find( this );
  const LocalBound bound = find == solution.end() ? BoundLocal : find->second;
  const bool wasLocal = modifiers & Local;
  bool changed;

  switch (bound) {
    
  case BoundGlobal:
      if (wasLocal)
	{
	  error( "local inference removed explicit locality qualification" );
	  (int &) modifiers &= ~Local;
	  return true;
	}
      else
	{
	  ++context.stats.alreadyGlobal;
	  return false;
	}
      
  case BoundLocal:
    if (wasLocal)
      {
	++context.stats.alreadyLocal;
	return false;
      }
    else
      {
	(int &) modifiers |= Local | LocalInferred;
	++context.stats.localized;
	return true;
      }
  }
}
