#include "AST.h"
#include "enact-context.h"
#include "stats.h"


bool TypeNode::localEnactType( const LocalEnactContext &context )
{
  return localInferable() && localEnactBits( context, _modifiers );
}


////////////////////////////////////////////////////////////////////////


bool ArrayTypeNode::localEnactType( const LocalEnactContext &context )
{
  bool changed = TypeNode::localEnactType( context );
  changed |= elementType()->localEnactType( context );
  return changed;
}


bool TypeListNode::localEnactType( const LocalEnactContext &context )
{
  bool changed = false;
  foriter (type, allTypes(), TypeIter)
    changed |= (*type)->localEnactType( context );
  return changed;
}
