#include "AST.h"

// Recursively go through a tree, fixing all the _parent pointers.
// Returns how many it fixed.
int TreeNode::fixParent()
{
  const int n = arity();
  int count = 0;

  for (int i = 0; i < n; ++i) {
    TreeNode *c = child(i);

    if (c != NULL) {
      if (c->_parent != this) {
	c->_parent = this;
	count++;
      }
      count += c->fixParent();
    }
  }

  return count;
}
