#include <pthread.h>
#include "barrier.h"
#include "procs.h"


static unsigned pending;
static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t done = PTHREAD_COND_INITIALIZER;


void barrier_init()
{
  pending = PROCS;
}


void barrier()
{
  pthread_mutex_lock( &mutex );
  
  if (--pending)
    pthread_cond_wait( &done, &mutex );
  else
    {
      pending = PROCS;
      pthread_cond_broadcast( &done );
    }

  pthread_mutex_unlock( &mutex );
}
