#ifndef _INCLUDE_MEM_NARROW_H_
#define _INCLUDE_MEM_NARROW_H_


#include <string.h>
#include "mem-local.h"

struct instance_header;


#define DEREF_GLOBAL		DEREF_LOCAL
#define ASSIGN_GLOBAL		ASSIGN_LOCAL
#define WEAK_ASSIGN_GLOBAL	WEAK_ASSIGN_LOCAL

#define PGASSIGN_GLOBAL		PGASSIGN_LOCAL
#define SPLASSIGN_GLOBAL	SPLASSIGN_LOCAL
#define SPGASSIGN_GLOBAL	SPGASSIGN_LOCAL
#define WEAK_ASSIGN_GLOBAL	WEAK_ASSIGN_LOCAL	
#define WEAK_PLASSIGN_GLOBAL	WEAK_PLASSIGN_LOCAL	
#define WEAK_PGASSIGN_GLOBAL	WEAK_PGASSIGN_LOCAL	
#define WEAK_SPLASSIGN_GLOBAL	WEAK_SPLASSIGN_LOCAL	
#define WEAK_SPGASSIGN_GLOBAL	WEAK_SPGASSIGN_LOCAL	

#define FIELD_ADDR_GLOBAL	FIELD_ADDR_LOCAL
#define IFACE_DISPATCH_GLOBAL	IFACE_DISPATCH_LOCAL
#define INDEX_GLOBAL		INDEX_LOCAL
#define EQUAL_GLOBAL		EQUAL_LOCAL

#define CLASS_INFO_GLOBAL	CLASS_INFO_LOCAL

#define PRE_INCR_GLOBAL		PRE_INCR_LOCAL
#define PRE_DECR_GLOBAL		PRE_DECR_LOCAL
#define POST_INCR_GLOBAL	POST_INCR_LOCAL
#define POST_DECR_GLOBAL	POST_DECR_LOCAL

#define TO_GLOBAL(global, proc, local)	globalize(global, local)
#define TO_LOCAL(ptr)			(ptr)
#define TO_PROC(ptr)			(0)

#define isLocal(ptr)			(1)
#define localize(local, global)		do { (local) = (global); } while (0)
#define globalize(global, local)	do { (global) = (local); } while (0)


#define local_to_global_copy( local, global, count )  memcpy( global, local, sizeof(*local) * count )
#define global_to_local_copy( global, local, count )  memcpy( local, global, sizeof(*local) * count )


#endif /* !_INCLUDE_MEM_NARROW_H_ */
