// Strange fiddlings required to use a nonstandard basic_string with g++

#include <iomanip.h>
#include "config.h"
#include "string16.h"


#if defined(__GNUC__) && (__GLIBC__ < 2 || __GLIBC_MINOR__ < 1)
#if __GNUC__ == 2 && __GNUC_MINOR__ <= 7
string16::Rep string16::nilRep = { 0, 0, 1, false };
#else
template class string16::Rep;
#endif
#endif


// This representation is suitable for human viewing,
// but cannot be fed into a C compiler.

#ifdef HAVE_TEMPLATE_SPECIALIZATION
template<>
#endif
ostream &operator<<( ostream &os, const string16 &string )
{
    const ios::fmtflags flags = os.setf( ios::hex, ios::basefield | ios::showbase );
    const char fill = os.fill( '0' );
    os << '"';
    
    for (unsigned pos = 0; pos < string.length(); ++pos) {
	const uint16 character = string[ pos ];
	switch (character) {
	case '\b': os << "\\b"; break;
	case '\t': os << "\\t"; break;
	case '\n': os << "\\n"; break;
	case '\f': os << "\\f"; break;
	case '\r': os << "\\r"; break;
	case '"' : os << "\\\""; break;
	case '\\': os << "\\\\"; break;
	default:
	    if (isascii( character ) && isprint( character ))
		os << (char) character;
	    else
		os << "\\u" << setw( 4 ) << character;
	}
    }

    os << '"';
    os.fill( fill );
    os.flags( flags );
    return os;
}


// This representation may be fed into a C compiler,
// but is not as good for human viewing.

void printEscaped( ostream &os, uint16 character )
{
    const ios::fmtflags flags = os.setf( ios::hex | ios::showbase, ios::basefield | ios::showbase );
    const char fill = os.fill( '0' );

    switch (character) {
    case '\b': os << "'\\b'"; break;
    case '\t': os << "'\\t'"; break;
    case '\n': os << "'\\n'"; break;
    case '\f': os << "'\\f'"; break;
    case '\r': os << "'\\r'"; break;
    case '\'': os << "'\\''"; break;
    case '"' : os << "'\\\"'"; break;
    case '\\': os << "'\\\\'"; break;
    default:
	if (isascii( character ) && isprint(character))
	    os << '\'' << char( character ) << '\'';
	else
	    os << character;
    }

    os.fill( fill );
    os.flags( flags );
}


// This representation may be fed into a C compiler,
// but is not as good for human viewing.

void printEscaped( ostream &os, const string16 &string )
{
    os << "{ ";
    bool first = true;
    
    for (unsigned pos = 0; pos < string.length(); ++pos) {
	if (first) first = false; else os << ", ";
	printEscaped( os, string[ pos ] );
    }

    os << " }";
}
